/* Display.c generated by valac 0.52.4, the Vala compiler
 * generated from Display.vala, do not modify */

/*
* Copyright 2017-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* widget to display/add/remove/move keyboard layouts*/

#include "keyboard.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

#define PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS (pantheon_keyboard_source_settings_get_type ())
#define PANTHEON_KEYBOARD_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS, PantheonKeyboardSourceSettings))
#define PANTHEON_KEYBOARD_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS, PantheonKeyboardSourceSettingsClass))
#define PANTHEON_KEYBOARD_IS_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS))
#define PANTHEON_KEYBOARD_IS_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS))
#define PANTHEON_KEYBOARD_SOURCE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS, PantheonKeyboardSourceSettingsClass))

typedef struct _PantheonKeyboardSourceSettings PantheonKeyboardSourceSettings;
typedef struct _PantheonKeyboardSourceSettingsClass PantheonKeyboardSourceSettingsClass;
enum  {
	PANTHEON_KEYBOARD_LAYOUT_PAGE_DISPLAY_0_PROPERTY,
	PANTHEON_KEYBOARD_LAYOUT_PAGE_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* pantheon_keyboard_layout_page_display_properties[PANTHEON_KEYBOARD_LAYOUT_PAGE_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PantheonKeyboardLayoutPageDisplayPrivate {
	PantheonKeyboardSourceSettings* settings;
	GtkTreeView* tree;
	GtkButton* up_button;
	GtkButton* down_button;
	GtkButton* add_button;
	GtkButton* remove_button;
	gboolean cursor_changing;
};

struct _Block6Data {
	int _ref_count_;
	PantheonKeyboardLayoutPageDisplay* self;
	guint index;
};

struct _Block7Data {
	int _ref_count_;
	PantheonKeyboardLayoutPageDisplay* self;
	GtkListStore* list_store;
	GtkTreeIter* iter;
	guint index;
};

static gint PantheonKeyboardLayoutPageDisplay_private_offset;
static gpointer pantheon_keyboard_layout_page_display_parent_class = NULL;

GType pantheon_keyboard_source_settings_get_type (void) G_GNUC_CONST ;
static void pantheon_keyboard_layout_page_display_update_buttons (PantheonKeyboardLayoutPageDisplay* self);
static gint pantheon_keyboard_layout_page_display_get_cursor_index (PantheonKeyboardLayoutPageDisplay* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void pantheon_keyboard_layout_page_display_update_cursor (PantheonKeyboardLayoutPageDisplay* self);
PantheonKeyboardInputSource* pantheon_keyboard_source_settings_get_active_input_source (PantheonKeyboardSourceSettings* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean ___lambda12_ (Block6Data* _data6_,
                       GtkTreeModel* model,
                       GtkTreePath* path,
                       GtkTreeIter* iter);
guint pantheon_keyboard_source_settings_get_active_index (PantheonKeyboardSourceSettings* self);
static gboolean ____lambda12__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                    GtkTreePath* path,
                                                    GtkTreeIter* iter,
                                                    gpointer self);
static void pantheon_keyboard_layout_page_display_rebuild_list (PantheonKeyboardLayoutPageDisplay* self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
static void block7_data_unref (void * _userdata_);
void pantheon_keyboard_source_settings_foreach_layout (PantheonKeyboardSourceSettings* self,
                                                       GFunc func,
                                                       gpointer func_target);
static void __lambda13_ (Block7Data* _data7_,
                  PantheonKeyboardInputSource* input_source);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static void ___lambda13__gfunc (gconstpointer data,
                         gpointer self);
static GObject * pantheon_keyboard_layout_page_display_constructor (GType type,
                                                             guint n_construct_properties,
                                                             GObjectConstructParam * construct_properties);
PantheonKeyboardSourceSettings* pantheon_keyboard_source_settings_get_instance (void);
static void _pantheon_keyboard_layout_page_display___lambda14_ (PantheonKeyboardLayoutPageDisplay* self);
static void __lambda26_ (PantheonKeyboardLayoutPageDisplay* self,
                  const gchar* layout,
                  const gchar* variant);
gboolean pantheon_keyboard_source_settings_add_layout (PantheonKeyboardSourceSettings* self,
                                                       PantheonKeyboardInputSource* new_layout);
static void ___lambda26__pantheon_keyboard_layout_page_add_layout_dialog_layout_added (PantheonKeyboardLayoutPageAddLayoutDialog* _sender,
                                                                                const gchar* language,
                                                                                const gchar* layout,
                                                                                gpointer self);
static void __pantheon_keyboard_layout_page_display___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self);
static void _pantheon_keyboard_layout_page_display___lambda27_ (PantheonKeyboardLayoutPageDisplay* self);
void pantheon_keyboard_source_settings_remove_active_layout (PantheonKeyboardSourceSettings* self);
static void __pantheon_keyboard_layout_page_display___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self);
static void _pantheon_keyboard_layout_page_display___lambda28_ (PantheonKeyboardLayoutPageDisplay* self);
void pantheon_keyboard_source_settings_move_active_layout_up (PantheonKeyboardSourceSettings* self);
static void __pantheon_keyboard_layout_page_display___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self);
static void _pantheon_keyboard_layout_page_display___lambda29_ (PantheonKeyboardLayoutPageDisplay* self);
void pantheon_keyboard_source_settings_move_active_layout_down (PantheonKeyboardSourceSettings* self);
static void __pantheon_keyboard_layout_page_display___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self);
static void _pantheon_keyboard_layout_page_display___lambda30_ (PantheonKeyboardLayoutPageDisplay* self);
void pantheon_keyboard_source_settings_set_active_index (PantheonKeyboardSourceSettings* self,
                                                         guint value);
static void __pantheon_keyboard_layout_page_display___lambda30__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                                                                       gpointer self);
static void _pantheon_keyboard_layout_page_display___lambda31_ (PantheonKeyboardLayoutPageDisplay* self);
static void __pantheon_keyboard_layout_page_display___lambda31__g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self);
static void _pantheon_keyboard_layout_page_display_rebuild_list_pantheon_keyboard_source_settings_external_layout_change (PantheonKeyboardSourceSettings* _sender,
                                                                                                                   gpointer self);
static void pantheon_keyboard_layout_page_display_finalize (GObject * obj);
static GType pantheon_keyboard_layout_page_display_get_type_once (void);

static inline gpointer
pantheon_keyboard_layout_page_display_get_instance_private (PantheonKeyboardLayoutPageDisplay* self)
{
	return G_STRUCT_MEMBER_P (self, PantheonKeyboardLayoutPageDisplay_private_offset);
}

static void
pantheon_keyboard_layout_page_display_update_buttons (PantheonKeyboardLayoutPageDisplay* self)
{
	gint rows = 0;
	GtkTreeView* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	gint index = 0;
	gboolean _tmp3_ = FALSE;
	GtkButton* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tree;
	_tmp1_ = gtk_tree_view_get_model (_tmp0_);
	_tmp2_ = _tmp1_;
	rows = gtk_tree_model_iter_n_children (_tmp2_, NULL);
	index = pantheon_keyboard_layout_page_display_get_cursor_index (self);
	if (rows > 1) {
		_tmp3_ = index != 0;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp4_ = self->priv->up_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, _tmp3_);
	if (rows > 1) {
		_tmp5_ = index < (rows - 1);
	} else {
		_tmp5_ = FALSE;
	}
	_tmp6_ = self->priv->down_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, _tmp5_);
	_tmp7_ = self->priv->remove_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, rows > 0);
}

/**
     * Returns the index of the selected (xkb) layout in the list of (all) input sources.
     * In case the list contains no layouts, it returns -1.
     */
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static gint
pantheon_keyboard_layout_page_display_get_cursor_index (PantheonKeyboardLayoutPageDisplay* self)
{
	GtkTreePath* path = NULL;
	GtkTreeView* _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	GtkTreePath* _tmp2_;
	GtkTreeIter iter = {0};
	GtkTreeView* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	guint index = 0U;
	GtkTreeView* _tmp8_;
	GtkTreeModel* _tmp9_;
	GtkTreeModel* _tmp10_;
	GtkTreeIter _tmp11_;
	guint _tmp12_ = 0U;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->tree;
	gtk_tree_view_get_cursor (_tmp0_, &_tmp1_, NULL);
	__vala_GtkTreePath_free0 (path);
	path = _tmp1_;
	_tmp2_ = path;
	if (_tmp2_ == NULL) {
		result = -1;
		__vala_GtkTreePath_free0 (path);
		return result;
	}
	_tmp3_ = self->priv->tree;
	_tmp4_ = gtk_tree_view_get_model (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = path;
	gtk_tree_model_get_iter (_tmp5_, &_tmp7_, _tmp6_);
	iter = _tmp7_;
	_tmp8_ = self->priv->tree;
	_tmp9_ = gtk_tree_view_get_model (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = iter;
	gtk_tree_model_get (_tmp10_, &_tmp11_, 2, &_tmp12_, -1, -1);
	index = _tmp12_;
	result = (gint) index;
	__vala_GtkTreePath_free0 (path);
	return result;
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		PantheonKeyboardLayoutPageDisplay* self;
		self = _data6_->self;
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static gboolean
___lambda12_ (Block6Data* _data6_,
              GtkTreeModel* model,
              GtkTreePath* path,
              GtkTreeIter* iter)
{
	PantheonKeyboardLayoutPageDisplay* self;
	GtkTreeView* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeIter _tmp3_;
	guint _tmp4_ = 0U;
	PantheonKeyboardSourceSettings* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gboolean result = FALSE;
	self = _data6_->self;
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->tree;
	_tmp1_ = gtk_tree_view_get_model (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = *iter;
	gtk_tree_model_get (_tmp2_, &_tmp3_, 2, &_tmp4_, -1);
	_data6_->index = _tmp4_;
	_tmp5_ = self->priv->settings;
	_tmp6_ = pantheon_keyboard_source_settings_get_active_index (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_data6_->index == _tmp7_) {
		GtkTreeView* _tmp8_;
		_tmp8_ = self->priv->tree;
		gtk_tree_view_set_cursor (_tmp8_, path, NULL, FALSE);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
____lambda12__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                           GtkTreePath* path,
                                           GtkTreeIter* iter,
                                           gpointer self)
{
	gboolean result;
	result = ___lambda12_ (self, model, path, iter);
	return result;
}

static void
pantheon_keyboard_layout_page_display_update_cursor (PantheonKeyboardLayoutPageDisplay* self)
{
	gboolean _tmp0_ = FALSE;
	GtkTreeView* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
	PantheonKeyboardSourceSettings* _tmp7_;
	PantheonKeyboardInputSource* _tmp8_;
	PantheonKeyboardInputSource* _tmp9_;
	PantheonKeyboardLayoutType _tmp10_;
	PantheonKeyboardLayoutType _tmp11_;
	g_return_if_fail (self != NULL);
	if (self->priv->cursor_changing) {
		_tmp0_ = TRUE;
	} else {
		PantheonKeyboardSourceSettings* _tmp1_;
		PantheonKeyboardInputSource* _tmp2_;
		PantheonKeyboardInputSource* _tmp3_;
		_tmp1_ = self->priv->settings;
		_tmp2_ = pantheon_keyboard_source_settings_get_active_input_source (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_ == NULL;
	}
	if (_tmp0_) {
		return;
	}
	_tmp4_ = self->priv->tree;
	_tmp5_ = gtk_tree_path_new ();
	_tmp6_ = _tmp5_;
	gtk_tree_view_set_cursor (_tmp4_, _tmp6_, NULL, FALSE);
	__vala_GtkTreePath_free0 (_tmp6_);
	_tmp7_ = self->priv->settings;
	_tmp8_ = pantheon_keyboard_source_settings_get_active_input_source (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = pantheon_keyboard_input_source_get_layout_type (_tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_ == PANTHEON_KEYBOARD_LAYOUT_TYPE_XKB) {
		Block6Data* _data6_;
		GtkTreeView* _tmp12_;
		GtkTreeModel* _tmp13_;
		GtkTreeModel* _tmp14_;
		_data6_ = g_slice_new0 (Block6Data);
		_data6_->_ref_count_ = 1;
		_data6_->self = g_object_ref (self);
		_data6_->index = (guint) 0;
		_tmp12_ = self->priv->tree;
		_tmp13_ = gtk_tree_view_get_model (_tmp12_);
		_tmp14_ = _tmp13_;
		gtk_tree_model_foreach (_tmp14_, ____lambda12__gtk_tree_model_foreach_func, _data6_);
		block6_data_unref (_data6_);
		_data6_ = NULL;
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
	g_boxed_free (gtk_tree_iter_get_type (), self);
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		PantheonKeyboardLayoutPageDisplay* self;
		self = _data7_->self;
		__vala_GtkTreeIter_free0 (_data7_->iter);
		_g_object_unref0 (_data7_->list_store);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
}

static void
__lambda13_ (Block7Data* _data7_,
             PantheonKeyboardInputSource* input_source)
{
	PantheonKeyboardLayoutPageDisplay* self;
	PantheonKeyboardLayoutType _tmp0_;
	PantheonKeyboardLayoutType _tmp1_;
	guint _tmp16_;
	self = _data7_->self;
	g_return_if_fail (input_source != NULL);
	_tmp0_ = pantheon_keyboard_input_source_get_layout_type (input_source);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == PANTHEON_KEYBOARD_LAYOUT_TYPE_XKB) {
		GtkTreeIter _tmp2_ = {0};
		GtkTreeIter _tmp3_;
		GtkTreeIter* _tmp4_;
		PantheonKeyboardXkbLayoutHandler* _tmp5_;
		PantheonKeyboardXkbLayoutHandler* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GtkTreeIter _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GtkTreeIter _tmp14_;
		GtkTreeIter _tmp15_;
		gtk_list_store_append (_data7_->list_store, &_tmp2_);
		__vala_GtkTreeIter_free0 (_data7_->iter);
		_tmp3_ = _tmp2_;
		_tmp4_ = __vala_GtkTreeIter_copy0 (&_tmp3_);
		_data7_->iter = _tmp4_;
		_tmp5_ = pantheon_keyboard_xkb_layout_handler_get_instance ();
		_tmp6_ = _tmp5_;
		_tmp7_ = pantheon_keyboard_input_source_get_name (input_source);
		_tmp8_ = _tmp7_;
		_tmp9_ = pantheon_keyboard_xkb_layout_handler_get_display_name (_tmp6_, _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = *_data7_->iter;
		gtk_list_store_set (_data7_->list_store, &_tmp11_, 0, _tmp10_, -1);
		_g_free0 (_tmp10_);
		_g_object_unref0 (_tmp6_);
		_tmp12_ = pantheon_keyboard_input_source_get_name (input_source);
		_tmp13_ = _tmp12_;
		_tmp14_ = *_data7_->iter;
		gtk_list_store_set (_data7_->list_store, &_tmp14_, 1, _tmp13_, -1);
		_tmp15_ = *_data7_->iter;
		gtk_list_store_set (_data7_->list_store, &_tmp15_, 2, _data7_->index, -1);
	}
	_tmp16_ = _data7_->index;
	_data7_->index = _tmp16_ + 1;
}

static void
___lambda13__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda13_ (self, (PantheonKeyboardInputSource*) data);
}

static void
pantheon_keyboard_layout_page_display_rebuild_list (PantheonKeyboardLayoutPageDisplay* self)
{
	Block7Data* _data7_;
	GtkListStore* _tmp0_;
	PantheonKeyboardSourceSettings* _tmp1_;
	GtkTreeView* _tmp2_;
	g_return_if_fail (self != NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_UINT, -1);
	_data7_->list_store = _tmp0_;
	_data7_->iter = NULL;
	_data7_->index = (guint) 0;
	_tmp1_ = self->priv->settings;
	pantheon_keyboard_source_settings_foreach_layout (_tmp1_, ___lambda13__gfunc, _data7_);
	_tmp2_ = self->priv->tree;
	gtk_tree_view_set_model (_tmp2_, (GtkTreeModel*) _data7_->list_store);
	pantheon_keyboard_layout_page_display_update_cursor (self);
	pantheon_keyboard_layout_page_display_update_buttons (self);
	block7_data_unref (_data7_);
	_data7_ = NULL;
}

PantheonKeyboardLayoutPageDisplay*
pantheon_keyboard_layout_page_display_construct (GType object_type)
{
	PantheonKeyboardLayoutPageDisplay * self = NULL;
	self = (PantheonKeyboardLayoutPageDisplay*) g_object_new (object_type, NULL);
	return self;
}

PantheonKeyboardLayoutPageDisplay*
pantheon_keyboard_layout_page_display_new (void)
{
	return pantheon_keyboard_layout_page_display_construct (PANTHEON_KEYBOARD_LAYOUT_PAGE_TYPE_DISPLAY);
}

static void
__lambda26_ (PantheonKeyboardLayoutPageDisplay* self,
             const gchar* layout,
             const gchar* variant)
{
	PantheonKeyboardSourceSettings* _tmp0_;
	PantheonKeyboardInputSource* _tmp1_;
	PantheonKeyboardInputSource* _tmp2_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (variant != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = pantheon_keyboard_input_source_new_xkb (layout, variant);
	_tmp2_ = _tmp1_;
	pantheon_keyboard_source_settings_add_layout (_tmp0_, _tmp2_);
	_g_object_unref0 (_tmp2_);
	pantheon_keyboard_layout_page_display_rebuild_list (self);
}

static void
___lambda26__pantheon_keyboard_layout_page_add_layout_dialog_layout_added (PantheonKeyboardLayoutPageAddLayoutDialog* _sender,
                                                                           const gchar* language,
                                                                           const gchar* layout,
                                                                           gpointer self)
{
	__lambda26_ ((PantheonKeyboardLayoutPageDisplay*) self, language, layout);
}

static void
_pantheon_keyboard_layout_page_display___lambda14_ (PantheonKeyboardLayoutPageDisplay* self)
{
	PantheonKeyboardLayoutPageAddLayoutDialog* dialog = NULL;
	PantheonKeyboardLayoutPageAddLayoutDialog* _tmp0_;
	PantheonKeyboardLayoutPageAddLayoutDialog* _tmp1_;
	GtkWidget* _tmp2_;
	PantheonKeyboardLayoutPageAddLayoutDialog* _tmp3_;
	PantheonKeyboardLayoutPageAddLayoutDialog* _tmp4_;
	_tmp0_ = pantheon_keyboard_layout_page_add_layout_dialog_new ();
	g_object_ref_sink (_tmp0_);
	dialog = _tmp0_;
	_tmp1_ = dialog;
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	gtk_window_set_transient_for ((GtkWindow*) _tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_window_get_type (), GtkWindow));
	_tmp3_ = dialog;
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
	_tmp4_ = dialog;
	g_signal_connect_object (_tmp4_, "layout-added", (GCallback) ___lambda26__pantheon_keyboard_layout_page_add_layout_dialog_layout_added, self, 0);
	_g_object_unref0 (dialog);
}

static void
__pantheon_keyboard_layout_page_display___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self)
{
	_pantheon_keyboard_layout_page_display___lambda14_ ((PantheonKeyboardLayoutPageDisplay*) self);
}

static void
_pantheon_keyboard_layout_page_display___lambda27_ (PantheonKeyboardLayoutPageDisplay* self)
{
	PantheonKeyboardSourceSettings* _tmp0_;
	_tmp0_ = self->priv->settings;
	pantheon_keyboard_source_settings_remove_active_layout (_tmp0_);
	pantheon_keyboard_layout_page_display_rebuild_list (self);
}

static void
__pantheon_keyboard_layout_page_display___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self)
{
	_pantheon_keyboard_layout_page_display___lambda27_ ((PantheonKeyboardLayoutPageDisplay*) self);
}

static void
_pantheon_keyboard_layout_page_display___lambda28_ (PantheonKeyboardLayoutPageDisplay* self)
{
	PantheonKeyboardSourceSettings* _tmp0_;
	_tmp0_ = self->priv->settings;
	pantheon_keyboard_source_settings_move_active_layout_up (_tmp0_);
	pantheon_keyboard_layout_page_display_rebuild_list (self);
}

static void
__pantheon_keyboard_layout_page_display___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self)
{
	_pantheon_keyboard_layout_page_display___lambda28_ ((PantheonKeyboardLayoutPageDisplay*) self);
}

static void
_pantheon_keyboard_layout_page_display___lambda29_ (PantheonKeyboardLayoutPageDisplay* self)
{
	PantheonKeyboardSourceSettings* _tmp0_;
	_tmp0_ = self->priv->settings;
	pantheon_keyboard_source_settings_move_active_layout_down (_tmp0_);
	pantheon_keyboard_layout_page_display_rebuild_list (self);
}

static void
__pantheon_keyboard_layout_page_display___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self)
{
	_pantheon_keyboard_layout_page_display___lambda29_ ((PantheonKeyboardLayoutPageDisplay*) self);
}

static void
_pantheon_keyboard_layout_page_display___lambda30_ (PantheonKeyboardLayoutPageDisplay* self)
{
	gint new_index = 0;
	self->priv->cursor_changing = TRUE;
	new_index = pantheon_keyboard_layout_page_display_get_cursor_index (self);
	if (new_index >= 0) {
		PantheonKeyboardSourceSettings* _tmp0_;
		_tmp0_ = self->priv->settings;
		pantheon_keyboard_source_settings_set_active_index (_tmp0_, (guint) new_index);
	}
	pantheon_keyboard_layout_page_display_update_buttons (self);
	self->priv->cursor_changing = FALSE;
}

static void
__pantheon_keyboard_layout_page_display___lambda30__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                                                                  gpointer self)
{
	_pantheon_keyboard_layout_page_display___lambda30_ ((PantheonKeyboardLayoutPageDisplay*) self);
}

static void
_pantheon_keyboard_layout_page_display___lambda31_ (PantheonKeyboardLayoutPageDisplay* self)
{
	pantheon_keyboard_layout_page_display_update_cursor (self);
}

static void
__pantheon_keyboard_layout_page_display___lambda31__g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self)
{
	_pantheon_keyboard_layout_page_display___lambda31_ ((PantheonKeyboardLayoutPageDisplay*) self);
}

static void
_pantheon_keyboard_layout_page_display_rebuild_list_pantheon_keyboard_source_settings_external_layout_change (PantheonKeyboardSourceSettings* _sender,
                                                                                                              gpointer self)
{
	pantheon_keyboard_layout_page_display_rebuild_list ((PantheonKeyboardLayoutPageDisplay*) self);
}

static GObject *
pantheon_keyboard_layout_page_display_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PantheonKeyboardLayoutPageDisplay * self;
	PantheonKeyboardSourceSettings* _tmp0_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp1_ = NULL;
	GtkTreeView* _tmp2_ = NULL;
	GtkTreeView* _tmp3_;
	GtkCellRendererText* _tmp4_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp5_ = NULL;
	GtkScrolledWindow* _tmp6_;
	GtkTreeView* _tmp7_;
	gchar* _tmp8_;
	GtkButton* _tmp9_ = NULL;
	gchar* _tmp10_;
	GtkButton* _tmp11_ = NULL;
	gchar* _tmp12_;
	GtkButton* _tmp13_ = NULL;
	gchar* _tmp14_;
	GtkButton* _tmp15_ = NULL;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp16_;
	GtkActionBar* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkActionBar* _tmp19_;
	GtkButton* _tmp20_;
	GtkActionBar* _tmp21_;
	GtkButton* _tmp22_;
	GtkActionBar* _tmp23_;
	GtkButton* _tmp24_;
	GtkActionBar* _tmp25_;
	GtkButton* _tmp26_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	GtkScrolledWindow* _tmp29_;
	GtkGrid* _tmp30_;
	GtkActionBar* _tmp31_;
	GtkGrid* _tmp32_;
	GtkButton* _tmp33_;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkTreeView* _tmp37_;
	PantheonKeyboardSourceSettings* _tmp38_;
	PantheonKeyboardSourceSettings* _tmp39_;
	parent_class = G_OBJECT_CLASS (pantheon_keyboard_layout_page_display_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_KEYBOARD_LAYOUT_PAGE_TYPE_DISPLAY, PantheonKeyboardLayoutPageDisplay);
	_tmp0_ = pantheon_keyboard_source_settings_get_instance ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_set (_tmp1_, "ellipsize-set", TRUE, NULL);
	g_object_set (_tmp1_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	g_object_ref_sink (_tmp1_);
	cell = _tmp1_;
	_tmp2_ = (GtkTreeView*) gtk_tree_view_new ();
	gtk_tree_view_set_headers_visible (_tmp2_, FALSE);
	g_object_set ((GtkWidget*) _tmp2_, "expand", TRUE, NULL);
	gtk_tree_view_set_tooltip_column (_tmp2_, 0);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->tree);
	self->priv->tree = _tmp2_;
	_tmp3_ = self->priv->tree;
	_tmp4_ = cell;
	gtk_tree_view_insert_column_with_attributes (_tmp3_, -1, NULL, (GtkCellRenderer*) _tmp4_, "text", 0, NULL);
	_tmp5_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set (_tmp5_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	g_object_set ((GtkWidget*) _tmp5_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp5_);
	scroll = _tmp5_;
	_tmp6_ = scroll;
	_tmp7_ = self->priv->tree;
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
	_tmp8_ = g_strdup (_ ("Add…"));
	_tmp9_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _tmp8_);
	_g_free0 (_tmp8_);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->add_button);
	self->priv->add_button = _tmp9_;
	_tmp10_ = g_strdup (_ ("Remove"));
	_tmp11_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp10_);
	_g_free0 (_tmp10_);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->remove_button);
	self->priv->remove_button = _tmp11_;
	_tmp12_ = g_strdup (_ ("Move up"));
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("go-up-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, FALSE);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _tmp12_);
	_g_free0 (_tmp12_);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->up_button);
	self->priv->up_button = _tmp13_;
	_tmp14_ = g_strdup (_ ("Move down"));
	_tmp15_ = (GtkButton*) gtk_button_new_from_icon_name ("go-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, FALSE);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp15_, _tmp14_);
	_g_free0 (_tmp14_);
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->down_button);
	self->priv->down_button = _tmp15_;
	_tmp16_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp16_);
	actionbar = _tmp16_;
	_tmp17_ = actionbar;
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
	gtk_style_context_add_class (_tmp18_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
	_tmp19_ = actionbar;
	_tmp20_ = self->priv->add_button;
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = actionbar;
	_tmp22_ = self->priv->remove_button;
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = actionbar;
	_tmp24_ = self->priv->up_button;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = actionbar;
	_tmp26_ = self->priv->down_button;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
	_tmp27_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp27_);
	grid = _tmp27_;
	_tmp28_ = grid;
	_tmp29_ = scroll;
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 0, 0, 1, 1);
	_tmp30_ = grid;
	_tmp31_ = actionbar;
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 0, 1, 1, 1);
	_tmp32_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
	_tmp33_ = self->priv->add_button;
	g_signal_connect_object (_tmp33_, "clicked", (GCallback) __pantheon_keyboard_layout_page_display___lambda14__gtk_button_clicked, self, 0);
	_tmp34_ = self->priv->remove_button;
	g_signal_connect_object (_tmp34_, "clicked", (GCallback) __pantheon_keyboard_layout_page_display___lambda27__gtk_button_clicked, self, 0);
	_tmp35_ = self->priv->up_button;
	g_signal_connect_object (_tmp35_, "clicked", (GCallback) __pantheon_keyboard_layout_page_display___lambda28__gtk_button_clicked, self, 0);
	_tmp36_ = self->priv->down_button;
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) __pantheon_keyboard_layout_page_display___lambda29__gtk_button_clicked, self, 0);
	_tmp37_ = self->priv->tree;
	g_signal_connect_object (_tmp37_, "cursor-changed", (GCallback) __pantheon_keyboard_layout_page_display___lambda30__gtk_tree_view_cursor_changed, self, G_CONNECT_AFTER);
	_tmp38_ = self->priv->settings;
	g_signal_connect_object ((GObject*) _tmp38_, "notify::active-index", (GCallback) __pantheon_keyboard_layout_page_display___lambda31__g_object_notify, self, 0);
	_tmp39_ = self->priv->settings;
	g_signal_connect_object (_tmp39_, "external-layout-change", (GCallback) _pantheon_keyboard_layout_page_display_rebuild_list_pantheon_keyboard_source_settings_external_layout_change, self, 0);
	pantheon_keyboard_layout_page_display_rebuild_list (self);
	_g_object_unref0 (grid);
	_g_object_unref0 (actionbar);
	_g_object_unref0 (scroll);
	_g_object_unref0 (cell);
	return obj;
}

static void
pantheon_keyboard_layout_page_display_class_init (PantheonKeyboardLayoutPageDisplayClass * klass,
                                                  gpointer klass_data)
{
	pantheon_keyboard_layout_page_display_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PantheonKeyboardLayoutPageDisplay_private_offset);
	G_OBJECT_CLASS (klass)->constructor = pantheon_keyboard_layout_page_display_constructor;
	G_OBJECT_CLASS (klass)->finalize = pantheon_keyboard_layout_page_display_finalize;
}

static void
pantheon_keyboard_layout_page_display_instance_init (PantheonKeyboardLayoutPageDisplay * self,
                                                     gpointer klass)
{
	self->priv = pantheon_keyboard_layout_page_display_get_instance_private (self);
	self->priv->cursor_changing = FALSE;
}

static void
pantheon_keyboard_layout_page_display_finalize (GObject * obj)
{
	PantheonKeyboardLayoutPageDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_KEYBOARD_LAYOUT_PAGE_TYPE_DISPLAY, PantheonKeyboardLayoutPageDisplay);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->tree);
	_g_object_unref0 (self->priv->up_button);
	_g_object_unref0 (self->priv->down_button);
	_g_object_unref0 (self->priv->add_button);
	_g_object_unref0 (self->priv->remove_button);
	G_OBJECT_CLASS (pantheon_keyboard_layout_page_display_parent_class)->finalize (obj);
}

static GType
pantheon_keyboard_layout_page_display_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PantheonKeyboardLayoutPageDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pantheon_keyboard_layout_page_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PantheonKeyboardLayoutPageDisplay), 0, (GInstanceInitFunc) pantheon_keyboard_layout_page_display_instance_init, NULL };
	GType pantheon_keyboard_layout_page_display_type_id;
	pantheon_keyboard_layout_page_display_type_id = g_type_register_static (gtk_frame_get_type (), "PantheonKeyboardLayoutPageDisplay", &g_define_type_info, 0);
	PantheonKeyboardLayoutPageDisplay_private_offset = g_type_add_instance_private (pantheon_keyboard_layout_page_display_type_id, sizeof (PantheonKeyboardLayoutPageDisplayPrivate));
	return pantheon_keyboard_layout_page_display_type_id;
}

GType
pantheon_keyboard_layout_page_display_get_type (void)
{
	static volatile gsize pantheon_keyboard_layout_page_display_type_id__volatile = 0;
	if (g_once_init_enter (&pantheon_keyboard_layout_page_display_type_id__volatile)) {
		GType pantheon_keyboard_layout_page_display_type_id;
		pantheon_keyboard_layout_page_display_type_id = pantheon_keyboard_layout_page_display_get_type_once ();
		g_once_init_leave (&pantheon_keyboard_layout_page_display_type_id__volatile, pantheon_keyboard_layout_page_display_type_id);
	}
	return pantheon_keyboard_layout_page_display_type_id__volatile;
}

